Index: c/src/lib/libbsp/m68k/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/Makefile.am	(revision e4927eceff2cd82ad24600a1e53a99d8996d843e)
+++ c/src/lib/libbsp/m68k/Makefile.am	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -3,4 +3,9 @@
 ## Descend into the @RTEMS_BSP_FAMILY@ directory
 SUBDIRS = @RTEMS_BSP_FAMILY@
+
+include_bspdir = $(includedir)/bsp
+include_bsp_HEADERS = shared/include/linker-symbols.h
+
+dist_project_lib_DATA = shared/startup/linkcmds.base
 
 EXTRA_DIST = shared/m68kpretaskinghook.c
@@ -14,4 +19,5 @@
 EXTRA_DIST += shared/gdbstub/m68k-stub.c shared/gdbstub/gdb_if.h
 
+include $(srcdir)/preinstall.am
 include $(top_srcdir)/../../../automake/subdirs.am
 include $(top_srcdir)/../../../automake/local.am
Index: c/src/lib/libbsp/m68k/genmcf548x/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/Makefile.am	(revision e4927eceff2cd82ad24600a1e53a99d8996d843e)
+++ c/src/lib/libbsp/m68k/genmcf548x/Makefile.am	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -4,6 +4,4 @@
 
 include_bspdir = $(includedir)/bsp
-
-dist_project_lib_DATA = bsp_specs
 
 include_HEADERS = include/bsp.h
@@ -19,10 +17,12 @@
 noinst_LIBRARIES = libbspstart.a
 libbspstart_a_SOURCES = start/start.S
+
+dist_project_lib_DATA = bsp_specs
+dist_project_lib_DATA += startup/linkcmds.m5484FireEngine.flash
+dist_project_lib_DATA += startup/linkcmds.COBRA5475
+dist_project_lib_DATA += startup/linkcmds.m5484FireEngine
+
 project_lib_DATA = start.$(OBJEXT)
-
 project_lib_DATA += startup/linkcmds
-EXTRA_DIST = startup/linkcmds.m5484FireEngine.flash
-EXTRA_DIST += startup/linkcmds.COBRA5475
-EXTRA_DIST += startup/linkcmds.m5484FireEngine
 
 noinst_LIBRARIES += libbsp.a
Index: c/src/lib/libbsp/m68k/genmcf548x/include/bsp.h
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/include/bsp.h	(revision e4927eceff2cd82ad24600a1e53a99d8996d843e)
+++ c/src/lib/libbsp/m68k/genmcf548x/include/bsp.h	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -77,6 +77,4 @@
 #define CONSOLE_PORT        0
 
-#define RAM_END 0x4000000 /* 64 MB */
-
 /* functions */
 
Index: c/src/lib/libbsp/m68k/genmcf548x/preinstall.am
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/preinstall.am	(revision e4927eceff2cd82ad24600a1e53a99d8996d843e)
+++ c/src/lib/libbsp/m68k/genmcf548x/preinstall.am	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -34,8 +34,4 @@
 PREINSTALL_DIRS += $(PROJECT_INCLUDE)/bsp/$(dirstamp)
 
-$(PROJECT_LIB)/bsp_specs: bsp_specs $(PROJECT_LIB)/$(dirstamp)
-	$(INSTALL_DATA) $< $(PROJECT_LIB)/bsp_specs
-PREINSTALL_FILES += $(PROJECT_LIB)/bsp_specs
-
 $(PROJECT_INCLUDE)/bsp.h: include/bsp.h $(PROJECT_INCLUDE)/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp.h
@@ -58,4 +54,20 @@
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/coverhd.h
 
+$(PROJECT_LIB)/bsp_specs: bsp_specs $(PROJECT_LIB)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_LIB)/bsp_specs
+PREINSTALL_FILES += $(PROJECT_LIB)/bsp_specs
+
+$(PROJECT_LIB)/linkcmds.m5484FireEngine.flash: startup/linkcmds.m5484FireEngine.flash $(PROJECT_LIB)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_LIB)/linkcmds.m5484FireEngine.flash
+PREINSTALL_FILES += $(PROJECT_LIB)/linkcmds.m5484FireEngine.flash
+
+$(PROJECT_LIB)/linkcmds.COBRA5475: startup/linkcmds.COBRA5475 $(PROJECT_LIB)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_LIB)/linkcmds.COBRA5475
+PREINSTALL_FILES += $(PROJECT_LIB)/linkcmds.COBRA5475
+
+$(PROJECT_LIB)/linkcmds.m5484FireEngine: startup/linkcmds.m5484FireEngine $(PROJECT_LIB)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_LIB)/linkcmds.m5484FireEngine
+PREINSTALL_FILES += $(PROJECT_LIB)/linkcmds.m5484FireEngine
+
 $(PROJECT_LIB)/start.$(OBJEXT): start.$(OBJEXT) $(PROJECT_LIB)/$(dirstamp)
 	$(INSTALL_DATA) $< $(PROJECT_LIB)/start.$(OBJEXT)
Index: c/src/lib/libbsp/m68k/genmcf548x/start/start.S
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/start/start.S	(revision e4927eceff2cd82ad24600a1e53a99d8996d843e)
+++ c/src/lib/libbsp/m68k/genmcf548x/start/start.S	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -48,4 +48,5 @@
 \*===============================================================*/
 #include <rtems/asm.h>
+#include <bsp/linker-symbols.h>
 
 /*===============================================================*\
@@ -58,5 +59,4 @@
 .extern mcf548x_init
 .extern boot_card
-.extern _SpInit
 
 /*===============================================================*\
@@ -76,5 +76,5 @@
 PUBLIC (InterruptVectorTable)
 SYM(InterruptVectorTable):
-INITSP:		.long	_SpInit		        /* Initial SP		  */
+INITSP:		.long	bsp_initstack_end	/* Initial SP		  */
 INITPC:		.long	start			/* Initial PC		  */
 vector002:	.long	asm_default_interrupt	/* Access Error		  */
@@ -336,4 +336,5 @@
 | Start of code                                                   |
 \*===============================================================*/
+.text
 PUBLIC (start)
 SYM(start):
@@ -411,5 +412,5 @@
     jsr	    mcf548x_init		/* Initialize mcf548x peripherals */
 
-    move.l  #_SpInit,sp		        /* relocate sp */
+    move.l  #bsp_initstack_end,sp	/* relocate sp */
 
     clrl    d0          		/* clear d0 */
Index: c/src/lib/libbsp/m68k/genmcf548x/startup/init548x.c
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/startup/init548x.c	(revision e4927eceff2cd82ad24600a1e53a99d8996d843e)
+++ c/src/lib/libbsp/m68k/genmcf548x/startup/init548x.c	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -44,6 +44,9 @@
 \*===============================================================*/
 
-#include <rtems.h>
 #include <bsp.h>
+
+#include <string.h>
+
+#include <bsp/linker-symbols.h>
 
 #if defined(HAS_LOW_LEVEL_INIT)
@@ -67,6 +70,4 @@
 extern uint8_t _CodeFlashBase[];
 extern uint8_t RamBase[];
-extern uint32_t InterruptVectorTable[];
-extern uint32_t _VectorRam[];
 
 void gpio_init(void);
@@ -78,7 +79,4 @@
 void mcf548x_init(void)
     {
-    uint32_t n;
-    uint8_t *dp, *sp;
-
 #if defined(HAS_LOW_LEVEL_INIT)
     /* set XLB arbiter timeouts */
@@ -94,34 +92,21 @@
 #endif /* defined(HAS_LOW_LEVEL_INIT) */
 
-    /* Copy the vector table to RAM */
-    if (_VectorRam != InterruptVectorTable)
-    {
-	for( n = 0; n < 256; n++)
-	  {
-      _VectorRam[n] = InterruptVectorTable[n];
-	  }
+    /* Copy the vector table to RAM if necessary */
+    if (bsp_vector0_size == bsp_vector1_size) {
+      memcpy(bsp_vector1_begin, bsp_vector0_begin, (size_t) bsp_vector1_size);
+      m68k_set_vbr((uint32_t)bsp_vector1_begin);
     }
 
-    m68k_set_vbr((uint32_t)_VectorRam);
-
     /* Move initialized data from ROM to RAM. */
-    if (_DataRom != _DataRam)
-    {
-		n = _DataEnd - _DataRam;
-        sp = (uint8_t *)_DataRom;
-        dp = (uint8_t *)_DataRam;
-		while(n--)
-           *dp++ = *sp++;
-     }
+    if (bsp_section_data_begin != bsp_section_data_load_begin) {
+      memcpy(
+        bsp_section_data_begin,
+        bsp_section_data_load_begin,
+        (size_t) bsp_section_data_size
+      );
+    }
 
     /* Zero uninitialized data */
-    if (_BssStart != _BssEnd)
-    {
-		n = _BssEnd - _BssStart;
-        sp = (uint8_t *)_BssStart;
-        while (n--)
-            *sp++ = 0;
-    }
-
+    memset(bsp_section_bss_begin, 0, (size_t) bsp_section_bss_size);
 }
 /********************************************************************/
Index: c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.COBRA5475
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.COBRA5475	(revision e4927eceff2cd82ad24600a1e53a99d8996d843e)
+++ c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.COBRA5475	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -63,168 +63,20 @@
 _BootFlashSize  = DEFINED(_BootFlashSize)  ? _BootFlashSize : (32 * 1024*1024);
 
-_VectorRam      = DEFINED(_VectorRam)      ? _VectorRam : _SdramBase;
-_DataRam        = DEFINED(_DataRam)        ? _DataRam   : _data_dest_start;
-_DataRom        = DEFINED(_DataRom)        ? _DataRom   : _data_src_start;
-_DataEnd        = DEFINED(_DataEnd)        ? _DataEnd   : _data_dest_end;
-_BssStart       = DEFINED(_BssStart)       ? _BssStart  : _clear_start;
-_BssEnd         = DEFINED(_BssEnd)         ? _BssEnd    : _clear_end;
-_SpInit         = DEFINED(_SpInit)         ? _SpInit    : _EndInitStackSpace;
+bsp_initstack_size = DEFINED(StackSize)    ? StackSize  : 0x800;  /* 2 kB   */
 
-_InitStackSize  = DEFINED(StackSize)       ? StackSize  : 0x800;  /* 2 kB   */
-_TopRamReserved = DEFINED(_TopRamReserved) ? _TopRamReserved : 0;
-
-RamBase        = DEFINED(_SdramBase)      ? _SdramBase : _SdramBase;
-RamSize        = DEFINED(_SdramSize)      ? _SdramSize : _SdramSize;
-HeapSize       = DEFINED(HeapSize)       ? HeapSize   : 0x0;
-_VBR            = DEFINED(_VBR)            ? _VBR       : RamBase;
+_VBR            = DEFINED(_VBR)            ? _VBR       : _SdramBase;
 
 __MBAR          = DEFINED(__MBAR)          ? __MBAR     : 0xFE000000;
 
-ENTRY(start)
 MEMORY
 {
-    sdram      : ORIGIN = 0xF0040000, LENGTH = 128M - 256K
+    sdram      : ORIGIN = 0xF0000000, LENGTH = 128M
     boot_flash : ORIGIN = 0xFC000000, LENGTH = 32M
 }
 
-SECTIONS
-{
-     
-    _header_offset = 0;
-    
-    /*
-     * Text, data and bss segments .vectors          
-     */    
-    .vectors : {
-                 *(.vectors*)
-               } >sdram
-    .text : {
-       
-        *(.text*)
-        *(.ram_code)
+REGION_ALIAS ("REGION_TEXT", sdram);
+REGION_ALIAS ("REGION_TEXT_LOAD", sdram);
+REGION_ALIAS ("REGION_DATA", sdram);
+REGION_ALIAS ("REGION_DATA_LOAD", sdram);
 
-        /*
-         * C++ constructors/destructors
-         */
-        *(.gnu.linkonce.t.*)
-
-        /*
-         * Initialization and finalization code.
-              *
-              * Various files can provide initialization and finalization
-         * functions.  crtbegin.o and crtend.o are two instances. The
-         * body of these functions are in .init and .fini sections. We
-         * accumulate the bodies here, and prepend function prologues
-         * from crti.o and function epilogues from crtn.o. crti.o must
-         * be linked first; crtn.o must be linked last.  Because these
-         * are wildcards, it doesn't matter if the user does not
-         * actually link against crti.o and crtn.o; the linker won't
-         * look for a file to match a wildcard.  The wildcard also
-         * means that it doesn't matter which directory crti.o and
-         * crtn.o are in. 
-         */
-        PROVIDE (_init = .);
-        *crti.o(.init)
-        *(.init)
-        *crtn.o(.init)
-        PROVIDE (_fini = .);
-        *crti.o(.fini)
-        *(.fini)
-        *crtn.o(.fini)
-
-        /*
-         * Special FreeBSD sysctl sections.
-         */
-        . = ALIGN (16);
-        __start_set_sysctl_set = .;
-        *(set_sysctl_*);
-        __stop_set_sysctl_set = ABSOLUTE(.);
-        *(set_domain_*);
-        *(set_pseudo_*);
-
-
-        /*
-         * C++ constructors/destructors
-         *
-         * gcc uses crtbegin.o to find the start of the constructors
-         * and destructors so we make sure it is first.  Because this
-         * is a wildcard, it doesn't matter if the user does not
-         * actually link against crtbegin.o; the linker won't look for
-         * a file to match a wildcard.  The wildcard also means that
-         * it doesn't matter which directory crtbegin.o is in. The
-         * constructor and destructor list are terminated in
-         * crtend.o.  The same comments apply to it.
-         */
-        . = ALIGN (16);
-        *crtbegin.o(.ctors)
-        *(.ctors)
-        *crtend.o(.ctors)
-        *crtbegin.o(.dtors)
-        *(.dtors)
-        *crtend.o(.dtors)
-
-        /*
-         * Exception frame info
-         */
-        . = ALIGN (16);
-        *(.eh_frame)
-
-        /*
-         * Read-only data
-         */
-        . = ALIGN (16);
-        _rodata_start = . ;
-        *(.rodata*)
-        *(.gnu.linkonce.r*)
-        
-        . = ALIGN (16);
-
-        *(.console_gdb_xfer)
-        *(.bootstrap_data)
-        . = ALIGN(16);
-        _estuff = .;
-    PROVIDE (_etext = .);
-    } >sdram
-        
-        .data : {
-        /*.data : {*/
-            PROVIDE( _data_dest_start = . );
-            PROVIDE( _copy_start = .);
-            *(.data*)
-            *(.gnu.linkonce.d*)
-            *(.gcc_except_table*)
-            *(.jcr)
-            . = ALIGN (16);
-            PROVIDE (_edata = .);
-        PROVIDE (_copy_end = .);
-        PROVIDE (_data_dest_end = . );
-        } >sdram
-
-        _data_src_start = _etext; /*LOADADDR(.data);*/
-        _data_src_end = _data_src_start + SIZEOF(.data);        
-        
-        .bss : {
-               PROVIDE (_clear_start = .);
-                *(.bss*)
-                *(COMMON)
-                . = ALIGN (16);
-                PROVIDE (end = .);
-                PROVIDE (_clear_end = .);
-                . = ALIGN (4);
-                PROVIDE (_StartInitStackSpace = .);
-                /*. = _StartInitStackSpace + _InitStackSize;*/
-                . += _InitStackSize;
-                PROVIDE (_EndInitStackSpace = .);
-                PROVIDE (WorkAreaBase = .);
-        } >sdram
-  /* Stabs debugging sections.  */
-  .stab 0 : { *(.stab) }
-  .stabstr 0 : { *(.stabstr) }
-  .stab.excl 0 : { *(.stab.excl) }
-  .stab.exclstr 0 : { *(.stab.exclstr) }
-  .stab.index 0 : { *(.stab.index) }
-  .stab.indexstr 0 : { *(.stab.indexstr) }
-  .comment 0 : { *(.comment) }
-
-PROVIDE (end_of_all = .);  
-}
+INCLUDE linkcmds.base
Index: c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.m5484FireEngine
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.m5484FireEngine	(revision e4927eceff2cd82ad24600a1e53a99d8996d843e)
+++ c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.m5484FireEngine	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -64,169 +64,21 @@
 _CodeFlashSize  = DEFINED(_CodeFlashSize)  ? _CodeFlashSize : (16 * 1024*1024);
 
-_VectorRam      = DEFINED(_VectorRam)      ? _VectorRam : _SdramBase;
-_DataRam        = DEFINED(_DataRam)        ? _DataRam   : _data_dest_start;
-_DataRom        = DEFINED(_DataRom)        ? _DataRom   : _data_src_start;
-_DataEnd        = DEFINED(_DataEnd)        ? _DataEnd   : _data_dest_end;
-_BssStart       = DEFINED(_BssStart)       ? _BssStart  : _clear_start;
-_BssEnd         = DEFINED(_BssEnd)         ? _BssEnd    : _clear_end;
-_SpInit         = DEFINED(_SpInit)         ? _SpInit    : _EndInitStackSpace;
+bsp_initstack_size = DEFINED(StackSize)    ? StackSize  : 0x800;  /* 2 kB   */
 
-_InitStackSize  = DEFINED(StackSize)       ? StackSize  : 0x800;  /* 2 kB   */
-_TopRamReserved = DEFINED(_TopRamReserved) ? _TopRamReserved : 0;
-
-RamBase        = DEFINED(_SdramBase)      ? _SdramBase : _SdramBase;
-RamSize        = DEFINED(_SdramSize)      ? _SdramSize : _SdramSize;
-HeapSize       = DEFINED(HeapSize)       ? HeapSize   : 0x0;
-_VBR            = DEFINED(_VBR)            ? _VBR       : RamBase;
+_VBR            = DEFINED(_VBR)            ? _VBR       : _SdramBase;
 
 __MBAR          = DEFINED(__MBAR)          ? __MBAR     : 0x10000000;
 
-ENTRY(start)
 MEMORY
 {
-    sdram      : ORIGIN = 0x400     , LENGTH = 64M - 0x400
+    sdram      : ORIGIN = 0x00000000, LENGTH = 64M
     code_flash : ORIGIN = 0xE0000000, LENGTH = 16M
     boot_flash : ORIGIN = 0xFF800000, LENGTH = 2M
 }
 
-SECTIONS
-{
-     
-    _header_offset = 0;
-    
-    /*
-     * Text, data and bss segments .vectors          
-     */    
-    .vectors : {
-                 *(.vectors*)
-               } >sdram
-    .text : {
-       
-        *(.text*)
-        *(.ram_code)
+REGION_ALIAS ("REGION_TEXT", sdram);
+REGION_ALIAS ("REGION_TEXT_LOAD", sdram);
+REGION_ALIAS ("REGION_DATA", sdram);
+REGION_ALIAS ("REGION_DATA_LOAD", sdram);
 
-        /*
-         * C++ constructors/destructors
-         */
-        *(.gnu.linkonce.t.*)
-
-        /*
-         * Initialization and finalization code.
-              *
-              * Various files can provide initialization and finalization
-         * functions.  crtbegin.o and crtend.o are two instances. The
-         * body of these functions are in .init and .fini sections. We
-         * accumulate the bodies here, and prepend function prologues
-         * from crti.o and function epilogues from crtn.o. crti.o must
-         * be linked first; crtn.o must be linked last.  Because these
-         * are wildcards, it doesn't matter if the user does not
-         * actually link against crti.o and crtn.o; the linker won't
-         * look for a file to match a wildcard.  The wildcard also
-         * means that it doesn't matter which directory crti.o and
-         * crtn.o are in. 
-         */
-        PROVIDE (_init = .);
-        *crti.o(.init)
-        *(.init)
-        *crtn.o(.init)
-        PROVIDE (_fini = .);
-        *crti.o(.fini)
-        *(.fini)
-        *crtn.o(.fini)
-
-        /*
-         * Special FreeBSD sysctl sections.
-         */
-        . = ALIGN (16);
-        __start_set_sysctl_set = .;
-        *(set_sysctl_*);
-        __stop_set_sysctl_set = ABSOLUTE(.);
-        *(set_domain_*);
-        *(set_pseudo_*);
-
-
-        /*
-         * C++ constructors/destructors
-         *
-         * gcc uses crtbegin.o to find the start of the constructors
-         * and destructors so we make sure it is first.  Because this
-         * is a wildcard, it doesn't matter if the user does not
-         * actually link against crtbegin.o; the linker won't look for
-         * a file to match a wildcard.  The wildcard also means that
-         * it doesn't matter which directory crtbegin.o is in. The
-         * constructor and destructor list are terminated in
-         * crtend.o.  The same comments apply to it.
-         */
-        . = ALIGN (16);
-        *crtbegin.o(.ctors)
-        *(.ctors)
-        *crtend.o(.ctors)
-        *crtbegin.o(.dtors)
-        *(.dtors)
-        *crtend.o(.dtors)
-
-        /*
-         * Exception frame info
-         */
-        . = ALIGN (16);
-        *(.eh_frame)
-
-        /*
-         * Read-only data
-         */
-        . = ALIGN (16);
-        _rodata_start = . ;
-        *(.rodata*)
-        *(.gnu.linkonce.r*)
-        
-        . = ALIGN (16);
-
-        *(.console_gdb_xfer)
-        *(.bootstrap_data)
-        . = ALIGN(16);
-        _estuff = .;
-    PROVIDE (_etext = .);
-    } >sdram
-        
-        .data : {
-        /*.data : {*/
-            PROVIDE( _data_dest_start = . );
-            PROVIDE( _copy_start = .);
-            *(.data*)
-            *(.gnu.linkonce.d*)
-            *(.gcc_except_table*)
-            *(.jcr)
-            . = ALIGN (16);
-            PROVIDE (_edata = .);
-        PROVIDE (_copy_end = .);
-        PROVIDE (_data_dest_end = . );
-        } >sdram
-
-        _data_src_start = _etext; /*LOADADDR(.data);*/
-        _data_src_end = _data_src_start + SIZEOF(.data);        
-        
-        .bss : {
-               PROVIDE (_clear_start = .);
-                *(.bss*)
-                *(COMMON)
-                . = ALIGN (16);
-                PROVIDE (end = .);
-                PROVIDE (_clear_end = .);
-                . = ALIGN (4);
-                PROVIDE (_StartInitStackSpace = .);
-                /*. = _StartInitStackSpace + _InitStackSize;*/
-                . += _InitStackSize;
-                PROVIDE (_EndInitStackSpace = .);
-                PROVIDE (WorkAreaBase = .);
-        } >sdram
-  /* Stabs debugging sections.  */
-  .stab 0 : { *(.stab) }
-  .stabstr 0 : { *(.stabstr) }
-  .stab.excl 0 : { *(.stab.excl) }
-  .stab.exclstr 0 : { *(.stab.exclstr) }
-  .stab.index 0 : { *(.stab.index) }
-  .stab.indexstr 0 : { *(.stab.indexstr) }
-  .comment 0 : { *(.comment) }
-
-PROVIDE (end_of_all = .);  
-}
+INCLUDE linkcmds.base
Index: c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.m5484FireEngine.flash
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.m5484FireEngine.flash	(revision e4927eceff2cd82ad24600a1e53a99d8996d843e)
+++ c/src/lib/libbsp/m68k/genmcf548x/startup/linkcmds.m5484FireEngine.flash	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -64,168 +64,21 @@
 _CodeFlashSize = DEFINED(_CodeFlashSize)  ? _CodeFlashSize : (16 * 1024 * 1024);
 
-_VectorRam     = DEFINED(_VectorRam)      ? _VectorRam     : _SdramBase;
-_DataRam       = DEFINED(_DataRam)        ? _DataRam       : _data_dest_start;
-_DataRom       = DEFINED(_DataRom)        ? _DataRom       : _data_src_start;
-_DataEnd       = DEFINED(_DataEnd)        ? _DataEnd       : _data_dest_end;
-_BssStart      = DEFINED(_BssStart)       ? _BssStart      : _clear_start;
-_BssEnd        = DEFINED(_BssEnd)         ? _BssEnd        : _clear_end;
-_SpInit        = DEFINED(_SpInit)         ? _SpInit        : _EndInitStackSpace;
-_InitStackSize = DEFINED(StackSize)       ? StackSize      : 0x2000;  /* 8 kB   */
-_TopRamReserved= DEFINED(_TopRamReserved) ? _TopRamReserved : 0;
+bsp_initstack_size = DEFINED(StackSize)    ? StackSize  : 0x800;  /* 2 kB   */
 
-RamBase       = DEFINED(_SdramBase)      ? _SdramBase      : _SdramBase;
-RamSize       = DEFINED(_SdramSize)      ? _SdramSize      : _SdramSize;
-HeapSize      = DEFINED(HeapSize)       ? HeapSize       : 0x0;
-_VBR           = DEFINED(_VBR)            ? _VBR            : RamBase;
+_VBR            = DEFINED(_VBR)            ? _VBR       : _SdramBase;
 
-__MBAR         = DEFINED(__MBAR)          ? __MBAR          : 0x10000000;
+__MBAR          = DEFINED(__MBAR)          ? __MBAR     : 0x10000000;
 
-ENTRY(start)
 MEMORY
 {
-    sdram      : ORIGIN = 0x400     , LENGTH = 64M - 0x400
+    sdram      : ORIGIN = 0x00000000, LENGTH = 64M
     code_flash : ORIGIN = 0xE0000000, LENGTH = 16M
     boot_flash : ORIGIN = 0xFF800000, LENGTH = 2M
 }
 
-SECTIONS
-{
-     
-    _header_offset = 0;
-    
-    /*
-     * Text, data and bss segments .vectors          
-     */    
-    .vectors : {
-                 *(.vectors*)
-               } >boot_flash
-    .text : {
-       
-        *(.text*)
-        *(.ram_code)
+REGION_ALIAS ("REGION_TEXT", boot_flash);
+REGION_ALIAS ("REGION_TEXT_LOAD", boot_flash);
+REGION_ALIAS ("REGION_DATA", sdram);
+REGION_ALIAS ("REGION_DATA_LOAD", boot_flash);
 
-        /*
-         * C++ constructors/destructors
-         */
-        *(.gnu.linkonce.t.*)
-
-        /*
-         * Initialization and finalization code.
-              *
-              * Various files can provide initialization and finalization
-         * functions.  crtbegin.o and crtend.o are two instances. The
-         * body of these functions are in .init and .fini sections. We
-         * accumulate the bodies here, and prepend function prologues
-         * from crti.o and function epilogues from crtn.o. crti.o must
-         * be linked first; crtn.o must be linked last.  Because these
-         * are wildcards, it doesn't matter if the user does not
-         * actually link against crti.o and crtn.o; the linker won't
-         * look for a file to match a wildcard.  The wildcard also
-         * means that it doesn't matter which directory crti.o and
-         * crtn.o are in. 
-         */
-        PROVIDE (_init = .);
-        *crti.o(.init)
-        *(.init)
-        *crtn.o(.init)
-        PROVIDE (_fini = .);
-        *crti.o(.fini)
-        *(.fini)
-        *crtn.o(.fini)
-
-        /*
-         * Special FreeBSD sysctl sections.
-         */
-        . = ALIGN (16);
-        __start_set_sysctl_set = .;
-        *(set_sysctl_*);
-        __stop_set_sysctl_set = ABSOLUTE(.);
-        *(set_domain_*);
-        *(set_pseudo_*);
-
-
-        /*
-         * C++ constructors/destructors
-         *
-         * gcc uses crtbegin.o to find the start of the constructors
-         * and destructors so we make sure it is first.  Because this
-         * is a wildcard, it doesn't matter if the user does not
-         * actually link against crtbegin.o; the linker won't look for
-         * a file to match a wildcard.  The wildcard also means that
-         * it doesn't matter which directory crtbegin.o is in. The
-         * constructor and destructor list are terminated in
-         * crtend.o.  The same comments apply to it.
-         */
-        . = ALIGN (16);
-        *crtbegin.o(.ctors)
-        *(.ctors)
-        *crtend.o(.ctors)
-        *crtbegin.o(.dtors)
-        *(.dtors)
-        *crtend.o(.dtors)
-
-        /*
-         * Exception frame info
-         */
-        . = ALIGN (16);
-        *(.eh_frame)
-
-        /*
-         * Read-only data
-         */
-        . = ALIGN (16);
-        _rodata_start = . ;
-        *(.rodata*)
-        *(.gnu.linkonce.r*)
-        
-        . = ALIGN (16);
-
-        *(.console_gdb_xfer)
-        *(.bootstrap_data)
-        . = ALIGN(16);
-        _estuff = .;
-    PROVIDE (_etext = .);
-    } >boot_flash
-        
-        .data : AT(LOADADDR(.text) + SIZEOF(.text)) {
-        /*.data : {*/
-            PROVIDE( _data_dest_start = . );
-            PROVIDE( _copy_start = .);
-            *(.data*)
-            *(.gnu.linkonce.d*)
-            *(.gcc_except_table*)
-            *(.jcr)
-            . = ALIGN (16);
-            PROVIDE (_edata = .);
-        PROVIDE (_copy_end = .);
-        PROVIDE (_data_dest_end = . );
-        } >sdram
-
-        _data_src_start = _etext; /*LOADADDR(.data);*/
-        _data_src_end = _data_src_start + SIZEOF(.data);        
-        
-        .bss : {
-               PROVIDE (_clear_start = .);
-                *(.bss*)
-                *(COMMON)
-                . = ALIGN (16);
-                PROVIDE (end = .);
-                PROVIDE (_clear_end = .);
-                . = ALIGN (4);
-                PROVIDE (_StartInitStackSpace = .);
-                /*. = _StartInitStackSpace + _InitStackSize;*/
-                . += _InitStackSize;
-                PROVIDE (_EndInitStackSpace = .);
-                PROVIDE (WorkAreaBase = .);
-        } >sdram
-  /* Stabs debugging sections.  */
-  .stab 0 : { *(.stab) }
-  .stabstr 0 : { *(.stabstr) }
-  .stab.excl 0 : { *(.stab.excl) }
-  .stab.exclstr 0 : { *(.stab.exclstr) }
-  .stab.index 0 : { *(.stab.index) }
-  .stab.indexstr 0 : { *(.stab.indexstr) }
-  .comment 0 : { *(.comment) }
-
-PROVIDE (end_of_all = .);  
-}
+INCLUDE linkcmds.base
Index: c/src/lib/libbsp/m68k/preinstall.am
===================================================================
--- c/src/lib/libbsp/m68k/preinstall.am	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
+++ c/src/lib/libbsp/m68k/preinstall.am	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -0,0 +1,33 @@
+## Automatically generated by ampolish3 - Do not edit
+
+if AMPOLISH3
+$(srcdir)/preinstall.am: Makefile.am
+	$(AMPOLISH3) $(srcdir)/Makefile.am > $(srcdir)/preinstall.am
+endif
+
+PREINSTALL_DIRS =
+DISTCLEANFILES = $(PREINSTALL_DIRS)
+
+all-am: $(PREINSTALL_FILES)
+
+PREINSTALL_FILES =
+CLEANFILES = $(PREINSTALL_FILES)
+
+$(PROJECT_LIB)/$(dirstamp):
+	@$(MKDIR_P) $(PROJECT_LIB)
+	@: > $(PROJECT_LIB)/$(dirstamp)
+PREINSTALL_DIRS += $(PROJECT_LIB)/$(dirstamp)
+
+$(PROJECT_INCLUDE)/bsp/$(dirstamp):
+	@$(MKDIR_P) $(PROJECT_INCLUDE)/bsp
+	@: > $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+PREINSTALL_DIRS += $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+
+$(PROJECT_INCLUDE)/bsp/linker-symbols.h: shared/include/linker-symbols.h $(PROJECT_INCLUDE)/bsp/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/bsp/linker-symbols.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/bsp/linker-symbols.h
+
+$(PROJECT_LIB)/linkcmds.base: shared/startup/linkcmds.base $(PROJECT_LIB)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_LIB)/linkcmds.base
+PREINSTALL_FILES += $(PROJECT_LIB)/linkcmds.base
+
Index: c/src/lib/libbsp/m68k/shared/include/linker-symbols.h
===================================================================
--- c/src/lib/libbsp/m68k/shared/include/linker-symbols.h	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
+++ c/src/lib/libbsp/m68k/shared/include/linker-symbols.h	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -0,0 +1,84 @@
+/**
+ * @file
+ *
+ * @ingroup bsp_linker
+ *
+ * @brief Symbols defined in linker command base file.
+ */
+
+/*
+ * Copyright (c) 2008-2013 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <info@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.com/license/LICENSE.
+ */
+
+#ifndef LIBBSP_M68K_SHARED_LINKER_SYMBOLS_H
+#define LIBBSP_M68K_SHARED_LINKER_SYMBOLS_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+/**
+ * @defgroup bsp_linker Linker Support
+ *
+ * @ingroup bsp_kit
+ *
+ * @brief Linker support.
+ *
+ * @{
+ */
+
+#ifndef ASM
+  #define LINKER_SYMBOL(sym) extern char sym [];
+#else
+  #define LINKER_SYMBOL(sym) .extern sym
+#endif
+
+LINKER_SYMBOL(bsp_vector0_begin)
+LINKER_SYMBOL(bsp_vector0_end)
+LINKER_SYMBOL(bsp_vector0_size)
+
+LINKER_SYMBOL(bsp_vector1_begin)
+LINKER_SYMBOL(bsp_vector1_end)
+LINKER_SYMBOL(bsp_vector1_size)
+
+LINKER_SYMBOL(bsp_section_text_begin)
+LINKER_SYMBOL(bsp_section_text_end)
+LINKER_SYMBOL(bsp_section_text_size)
+LINKER_SYMBOL(bsp_section_text_load_begin)
+LINKER_SYMBOL(bsp_section_text_load_end)
+
+LINKER_SYMBOL(bsp_section_data_begin)
+LINKER_SYMBOL(bsp_section_data_end)
+LINKER_SYMBOL(bsp_section_data_size)
+LINKER_SYMBOL(bsp_section_data_load_begin)
+LINKER_SYMBOL(bsp_section_data_load_end)
+
+LINKER_SYMBOL(bsp_section_bss_begin)
+LINKER_SYMBOL(bsp_section_bss_end)
+LINKER_SYMBOL(bsp_section_bss_size)
+
+LINKER_SYMBOL(bsp_section_work_begin)
+LINKER_SYMBOL(bsp_section_work_end)
+LINKER_SYMBOL(bsp_section_work_size)
+
+LINKER_SYMBOL(bsp_initstack_begin)
+LINKER_SYMBOL(bsp_initstack_end)
+LINKER_SYMBOL(bsp_initstack_size)
+
+/** @} */
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* LIBBSP_M68K_SHARED_LINKER_SYMBOLS_H */
Index: c/src/lib/libbsp/m68k/shared/startup/linkcmds.base
===================================================================
--- c/src/lib/libbsp/m68k/shared/startup/linkcmds.base	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
+++ c/src/lib/libbsp/m68k/shared/startup/linkcmds.base	(revision 6440903c48460f4ad40bcdeb31e619e555a394e5)
@@ -0,0 +1,313 @@
+/*
+ * Copyright (c) 2008-2013 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <rtems@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.com/license/LICENSE.
+ */
+
+OUTPUT_FORMAT("elf32-m68k", "elf32-m68k", "elf32-m68k")
+
+OUTPUT_ARCH(m68k)
+
+ENTRY(_start)
+
+bsp_initstack_size = DEFINED (bsp_initstack_size) ? bsp_initstack_size : 2048;
+
+MEMORY {
+	UNEXPECTED_SECTIONS : ORIGIN = 0xffffffff, LENGTH = 0
+}
+
+SECTIONS {
+	.vector0 : ALIGN_WITH_INPUT {
+		bsp_vector0_begin = .;
+		*(.vectors*)
+		bsp_vector0_end = .;
+	} > REGION_TEXT AT > REGION_TEXT
+	bsp_vector0_size = bsp_vector0_end - bsp_vector0_begin;
+
+	.text : ALIGN_WITH_INPUT {
+		*(.text.unlikely .text.*_unlikely)
+		*(.text .stub .text.* .gnu.linkonce.t.*)
+		/* .gnu.warning sections are handled specially by elf32.em.  */
+		*(.gnu.warning)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.init : ALIGN_WITH_INPUT {
+		KEEP (*(.init))
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.fini : ALIGN_WITH_INPUT {
+		KEEP (*(.fini))
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.rodata : ALIGN_WITH_INPUT {
+		*(.rodata .rodata.* .gnu.linkonce.r.*)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.rodata1 : ALIGN_WITH_INPUT {
+		*(.rodata1)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.eh_frame : ALIGN_WITH_INPUT {
+		KEEP (*(.eh_frame))
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.gcc_except_table : ALIGN_WITH_INPUT {
+		*(.gcc_except_table .gcc_except_table.*)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.tdata : ALIGN_WITH_INPUT {
+		*(.tdata .tdata.* .gnu.linkonce.td.*)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.tbss : ALIGN_WITH_INPUT {
+		*(.tbss .tbss.* .gnu.linkonce.tb.*) *(.tcommon)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.preinit_array : ALIGN_WITH_INPUT {
+		PROVIDE_HIDDEN (__preinit_array_start = .);
+		KEEP (*(.preinit_array))
+		PROVIDE_HIDDEN (__preinit_array_end = .);
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.init_array : ALIGN_WITH_INPUT {
+		PROVIDE_HIDDEN (__init_array_start = .);
+		KEEP (*(SORT(.init_array.*)))
+		KEEP (*(.init_array))
+		PROVIDE_HIDDEN (__init_array_end = .);
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.fini_array : ALIGN_WITH_INPUT {
+		PROVIDE_HIDDEN (__fini_array_start = .);
+		KEEP (*(.fini_array))
+		KEEP (*(SORT(.fini_array.*)))
+		PROVIDE_HIDDEN (__fini_array_end = .);
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.ctors : ALIGN_WITH_INPUT {
+		/* gcc uses crtbegin.o to find the start of
+		   the constructors, so we make sure it is
+		   first.  Because this is a wildcard, it
+		   doesn't matter if the user does not
+		   actually link against crtbegin.o; the
+		   linker won't look for a file to match a
+		   wildcard.  The wildcard also means that it
+		   doesn't matter which directory crtbegin.o
+		   is in.  */
+		KEEP (*crtbegin.o(.ctors))
+		KEEP (*crtbegin?.o(.ctors))
+		/* We don't want to include the .ctor section from
+		   the crtend.o file until after the sorted ctors.
+		   The .ctor section from the crtend file contains the
+		   end of ctors marker and it must be last */
+		KEEP (*(EXCLUDE_FILE (*crtend.o *crtend?.o ) .ctors))
+		KEEP (*(SORT(.ctors.*)))
+		KEEP (*(.ctors))
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.dtors : ALIGN_WITH_INPUT {
+		KEEP (*crtbegin.o(.dtors))
+		KEEP (*crtbegin?.o(.dtors))
+		KEEP (*(EXCLUDE_FILE (*crtend.o *crtend?.o ) .dtors))
+		KEEP (*(SORT(.dtors.*)))
+		KEEP (*(.dtors))
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.data.rel.ro : ALIGN_WITH_INPUT {
+		*(.data.rel.ro.local* .gnu.linkonce.d.rel.ro.local.*)
+		*(.data.rel.ro* .gnu.linkonce.d.rel.ro.*)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.jcr : ALIGN_WITH_INPUT {
+		KEEP (*(.jcr))
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.interp : ALIGN_WITH_INPUT {
+		*(.interp)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.note.gnu.build-id : ALIGN_WITH_INPUT {
+		*(.note.gnu.build-id)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.hash : ALIGN_WITH_INPUT {
+		*(.hash)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.gnu.hash : ALIGN_WITH_INPUT {
+		*(.gnu.hash)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.dynsym : ALIGN_WITH_INPUT {
+		*(.dynsym)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.dynstr : ALIGN_WITH_INPUT {
+		*(.dynstr)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.gnu.version : ALIGN_WITH_INPUT {
+		*(.gnu.version)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.gnu.version_d : ALIGN_WITH_INPUT {
+		*(.gnu.version_d)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.gnu.version_r : ALIGN_WITH_INPUT {
+		*(.gnu.version_r)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.rel.dyn : ALIGN_WITH_INPUT {
+		*(.rel.init)
+		*(.rel.text .rel.text.* .rel.gnu.linkonce.t.*)
+		*(.rel.fini)
+		*(.rel.rodata .rel.rodata.* .rel.gnu.linkonce.r.*)
+		*(.rel.data.rel.ro* .rel.gnu.linkonce.d.rel.ro.*)
+		*(.rel.data .rel.data.* .rel.gnu.linkonce.d.*)
+		*(.rel.tdata .rel.tdata.* .rel.gnu.linkonce.td.*)
+		*(.rel.tbss .rel.tbss.* .rel.gnu.linkonce.tb.*)
+		*(.rel.ctors)
+		*(.rel.dtors)
+		*(.rel.got)
+		*(.rel.bss .rel.bss.* .rel.gnu.linkonce.b.*)
+		PROVIDE_HIDDEN (__rel_iplt_start = .);
+		*(.rel.iplt)
+		PROVIDE_HIDDEN (__rel_iplt_end = .);
+		PROVIDE_HIDDEN (__rela_iplt_start = .);
+		PROVIDE_HIDDEN (__rela_iplt_end = .);
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.rela.dyn : ALIGN_WITH_INPUT {
+		*(.rela.init)
+		*(.rela.text .rela.text.* .rela.gnu.linkonce.t.*)
+		*(.rela.fini)
+		*(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*)
+		*(.rela.data .rela.data.* .rela.gnu.linkonce.d.*)
+		*(.rela.tdata .rela.tdata.* .rela.gnu.linkonce.td.*)
+		*(.rela.tbss .rela.tbss.* .rela.gnu.linkonce.tb.*)
+		*(.rela.ctors)
+		*(.rela.dtors)
+		*(.rela.got)
+		*(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*)
+		PROVIDE_HIDDEN (__rel_iplt_start = .);
+		PROVIDE_HIDDEN (__rel_iplt_end = .);
+		PROVIDE_HIDDEN (__rela_iplt_start = .);
+		*(.rela.iplt)
+		PROVIDE_HIDDEN (__rela_iplt_end = .);
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.rel.plt : ALIGN_WITH_INPUT {
+		*(.rel.plt)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.rela.plt : ALIGN_WITH_INPUT {
+		*(.rela.plt)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.plt : ALIGN_WITH_INPUT {
+		*(.plt)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.iplt : ALIGN_WITH_INPUT {
+		*(.iplt)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.dynamic : ALIGN_WITH_INPUT {
+		*(.dynamic)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.got : ALIGN_WITH_INPUT {
+		*(.got.plt) *(.igot.plt) *(.got) *(.igot)
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+	.rtemsroset : ALIGN_WITH_INPUT {
+		/* Special FreeBSD linker set sections */
+		__start_set_sysctl_set = .;
+		*(set_sysctl_*);
+		__stop_set_sysctl_set = .;
+		*(set_domain_*);
+		*(set_pseudo_*);
+
+		KEEP (*(SORT(.rtemsroset.*)))
+	} > REGION_TEXT AT > REGION_TEXT_LOAD
+
+	.vector1 : ALIGN_WITH_INPUT {
+		bsp_vector1_begin = .;
+		. = . + (ORIGIN (REGION_TEXT) == ORIGIN (REGION_DATA) ? 0 : bsp_vector0_size);
+		bsp_vector1_end = .;
+	} > REGION_DATA AT > REGION_DATA
+	bsp_vector1_size = bsp_vector1_end - bsp_vector1_begin;
+
+	.initstack : ALIGN_WITH_INPUT {
+		bsp_initstack_begin = .;
+		. = . + bsp_initstack_size;
+		bsp_initstack_end = .;
+	} > REGION_DATA AT > REGION_DATA
+
+	.data : ALIGN_WITH_INPUT {
+		bsp_section_data_begin = .;
+		*(.data .data.* .gnu.linkonce.d.*)
+		SORT(CONSTRUCTORS)
+	} > REGION_DATA AT > REGION_DATA_LOAD
+	.data1 : ALIGN_WITH_INPUT {
+		*(.data1)
+	} > REGION_DATA AT > REGION_DATA_LOAD
+	.rtemsrwset : ALIGN_WITH_INPUT {
+		KEEP (*(SORT(.rtemsrwset.*)))
+		bsp_section_data_end = .;
+	} > REGION_DATA AT > REGION_DATA_LOAD
+	bsp_section_data_size = bsp_section_data_end - bsp_section_data_begin;
+	bsp_section_data_load_begin = LOADADDR (.data);
+	bsp_section_data_load_end = bsp_section_data_load_begin + bsp_section_data_size;
+
+	.bss : ALIGN_WITH_INPUT {
+		bsp_section_bss_begin = .;
+		*(.dynbss)
+		*(.bss .bss.* .gnu.linkonce.b.*)
+		*(COMMON)
+		bsp_section_bss_end = .;
+	} > REGION_DATA AT > REGION_DATA
+	bsp_section_bss_size = bsp_section_bss_end - bsp_section_bss_begin;
+
+	.work : ALIGN_WITH_INPUT {
+		/*
+		 * The work section will occupy the remaining REGION_DATA region and
+		 * contains the RTEMS work space and heap.
+		 */
+		bsp_section_work_begin = .;
+		. += ORIGIN (REGION_DATA) + LENGTH (REGION_DATA) - ABSOLUTE (.);
+		bsp_section_work_end = .;
+	} > REGION_DATA AT > REGION_DATA
+	bsp_section_work_size = bsp_section_work_end - bsp_section_work_begin;
+
+	/* FIXME */
+	RamBase = ORIGIN (REGION_DATA);
+	RamSize = LENGTH (REGION_DATA);
+	WorkAreaBase = bsp_section_work_begin;
+	HeapSize = 0;
+
+	/* Stabs debugging sections.  */
+	.stab          0 : { *(.stab) }
+	.stabstr       0 : { *(.stabstr) }
+	.stab.excl     0 : { *(.stab.excl) }
+	.stab.exclstr  0 : { *(.stab.exclstr) }
+	.stab.index    0 : { *(.stab.index) }
+	.stab.indexstr 0 : { *(.stab.indexstr) }
+	.comment       0 : { *(.comment) }
+	/* DWARF debug sections.
+	   Symbols in the DWARF debugging sections are relative to the beginning
+	   of the section so we begin them at 0.  */
+	/* DWARF 1 */
+	.debug          0 : { *(.debug) }
+	.line           0 : { *(.line) }
+	/* GNU DWARF 1 extensions */
+	.debug_srcinfo  0 : { *(.debug_srcinfo) }
+	.debug_sfnames  0 : { *(.debug_sfnames) }
+	/* DWARF 1.1 and DWARF 2 */
+	.debug_aranges  0 : { *(.debug_aranges) }
+	.debug_pubnames 0 : { *(.debug_pubnames) }
+	/* DWARF 2 */
+	.debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }
+	.debug_abbrev   0 : { *(.debug_abbrev) }
+	.debug_line     0 : { *(.debug_line) }
+	.debug_frame    0 : { *(.debug_frame) }
+	.debug_str      0 : { *(.debug_str) }
+	.debug_loc      0 : { *(.debug_loc) }
+	.debug_macinfo  0 : { *(.debug_macinfo) }
+	/* SGI/MIPS DWARF 2 extensions */
+	.debug_weaknames 0 : { *(.debug_weaknames) }
+	.debug_funcnames 0 : { *(.debug_funcnames) }
+	.debug_typenames 0 : { *(.debug_typenames) }
+	.debug_varnames  0 : { *(.debug_varnames) }
+	/* DWARF 3 */
+	.debug_pubtypes 0 : { *(.debug_pubtypes) }
+	.debug_ranges   0 : { *(.debug_ranges) }
+	/* DWARF extension */
+	.debug_macro    0 : { *(.debug_macro) }
+	/DISCARD/ : { *(.note.GNU-stack) *(.gnu_debuglink) *(.gnu.lto_*) }
+
+	/*
+	 * This is a RTEMS specific section to catch all unexpected input
+	 * sections.  In case you get an error like
+	 *   "section `.unexpected_sections' will not fit in region
+	 *   `UNEXPECTED_SECTIONS'"
+	 * you have to figure out the offending input section and add it to the
+	 * appropriate output section definition above.
+	 */
+	.unexpected_sections : { *(*) } > UNEXPECTED_SECTIONS
+}
